Index: test/edu/ucsb/nceas/metacattest/ReplicationServerListTest.java
===================================================================
--- test/edu/ucsb/nceas/metacattest/ReplicationServerListTest.java	(nonexistent)
+++ test/edu/ucsb/nceas/metacattest/ReplicationServerListTest.java	(revision 1292)
@@ -0,0 +1,308 @@
+/**
+ *  '$RCSfile$'
+ *  Copyright: 2000 Regents of the University of California and the
+ *              National Center for Ecological Analysis and Synthesis
+ *  Purpose: To test the ReplicationServerList class by JUnit
+ *    Authors: @Jing Tao@
+ *    Release: @release@
+ *
+ *   '$Author$'
+ *     '$Date$'
+ * '$Revision$'
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+
+package edu.ucsb.nceas.metacattest;
+
+import edu.ucsb.nceas.metacat.*;
+//import edu.ucsb.nceas.morpho.framework.*;
+import junit.framework.Test;
+import junit.framework.TestCase;
+import junit.framework.TestResult;
+import junit.framework.TestSuite;
+
+import java.io.*;
+import java.net.*;
+import java.util.*;
+
+
+/**
+ * A JUnit test for testing Step class processing
+ */
+public class ReplicationServerListTest extends TestCase
+{
+  private static String metacatReplicationURL=
+                                   MetaCatUtil.getOption("junitreplicationurl");
+  private ReplicationServerList serverList = null;
+  /**
+   * Constructor to build the test
+   *
+   * @param name the name of the test method
+   */
+  public ReplicationServerListTest(String name)
+  {
+    super(name);
+  }
+
+  /**
+   * Constructor to build the test
+   *
+   * @param name the name of the test method
+   * @param list the ReplicationServerList will be passed int
+   */
+  public ReplicationServerListTest(String name, ReplicationServerList list)
+  {
+    super(name);
+    serverList=list;
+  }
+ 
+  /**
+   * Establish a testing framework by initializing appropriate objects
+   */
+  public void setUp()
+ {
+   
+ }
+
+  /**
+   * Release any objects after tests are complete
+   */
+  public void tearDown()
+  {
+    //DBConnectionPool will be release
+    DBConnectionPool.release();
+  }
+
+  /**
+   * Create a suite of tests to be run together
+   */
+  public static Test suite()
+  {
+     //Get DBConnection pool, this is only for junit test.
+    //Because DBConnection is singleton class. So there is only one DBConnection
+    //pool in the program
+    try
+    {
+      DBConnectionPool pool = DBConnectionPool.getInstance();
+    }//try
+    catch (Exception e)
+    {
+      MetaCatUtil.debugMessage("Error in ReplicationServerList() to get" +
+                        " DBConnection pool"+e.getMessage(), 30);
+    }//catch
+    
+    TestSuite suite = new TestSuite();
+    suite.addTest(new ReplicationServerListTest("initialize"));
+    
+    try
+    {
+  
+    //Add two server into xml_replication table
+    URL dev = new URL(metacatReplicationURL+"?action=servercontrol&server=dev"+
+                        "&subaction=add&replicate=1&datareplicate=1&hub=1");
+    URL epsilon = new URL(metacatReplicationURL+"?action=servercontrol"+
+             "&server=epsilon&subaction=add&replicate=0&datareplicate=1&hub=0");
+    InputStream input = dev.openStream();
+    input.close();
+    input = epsilon.openStream();
+    input.close();
+    
+    //create a new server list
+    ReplicationServerList list = new ReplicationServerList();
+    
+    //Doing test test cases
+    suite.addTest(new ReplicationServerListTest("testSize", list));
+    
+    suite.addTest(new ReplicationServerListTest("testServerAt0", list));
+    suite.addTest(new ReplicationServerListTest("testServerAt1", list));
+    
+    suite.addTest(new ReplicationServerListTest
+                                              ("testNonEmptyServerList", list));
+    
+    suite.addTest(new ReplicationServerListTest("testServerIsNotInList", list));
+    suite.addTest(new ReplicationServerListTest("testServerIsInList", list));
+    
+    suite.addTest(new ReplicationServerListTest
+                                              ("testGetLastCheckedDate", list));
+    
+    suite.addTest(new ReplicationServerListTest
+                                        ("testGetReplicationValueFalse", list));
+    
+    suite.addTest(new ReplicationServerListTest
+                                         ("testGetReplicationValueTrue", list));
+    suite.addTest(new ReplicationServerListTest
+                                    ("testGetDataReplicationValueFalse", list));
+    
+    suite.addTest(new ReplicationServerListTest("testGetHubValueTrue", list));
+    suite.addTest(new ReplicationServerListTest("testGetHubValueFalse", list));
+    
+    //Delete this two server
+    URL deleteDev = new URL(metacatReplicationURL+"?action=servercontrol" +
+                                        "&server=dev&subaction=delete");
+    URL deleteEpsilon = new URL(metacatReplicationURL+"?action=servercontrol" +
+                                        "&server=epsilon&subaction=delete");
+    input = deleteDev.openStream();
+    input.close();
+    input = deleteEpsilon.openStream();
+    input.close();                                   
+    }//try
+    catch (Exception e)
+    {
+      MetaCatUtil.debugMessage("Error in ReplicationServerListTest.suite: "+
+                                e.getMessage(), 10);
+    }//catch
+    
+ 
+    
+                              
+    return suite;
+  }
+  
+
+
+  /**
+   * Run an initial test that always passes to check that the test
+   * harness is working.
+   */
+  public void initialize()
+  {
+    assert(1 == 1);
+  }
+
+   
+  /**
+   * Test the a empty server list is empty
+   */
+  public void testEmptyServerList()
+  {
+    
+    assert(serverList.isEmpty());
+  }
+  
+  /**
+   * Test the a non-empty server list is non-empty
+   */
+  public void testNonEmptyServerList()
+  {
+    
+    assert(!serverList.isEmpty());
+  }
+  
+  /**
+   * Test the size() method
+   */
+  public void testSize()
+  {
+    int size = serverList.size();
+    assert(size ==2);
+  }
+  
+  /**
+   * Test the method serverAt(0)
+   */
+  public void testServerAt0()
+  {
+    ReplicationServer server = serverList.serverAt(0);
+    String serverName = server.getServerName();
+    assert(serverName.equals("dev"));
+  }
+  
+  /**
+   * Test the method serverAt(1)
+   */
+  public void testServerAt1()
+  {
+    ReplicationServer server = serverList.serverAt(1);
+    String serverName = server.getServerName();
+    assert(serverName.equals("epsilon"));
+  }
+   
+  
+  /**
+   * Test the a given server is not in the server list
+   */
+  public void testServerIsNotInList()
+  {
+    assert(!serverList.isGivenServerInList("localhost"));
+  }
+  
+  /**
+   * Test the a given server is in the server list
+   */
+  public void testServerIsInList()
+  {
+    assert(serverList.isGivenServerInList("dev"));
+  }
+  
+  /**
+   * Test the method getLastCheckedDate
+   */
+  public void testGetLastCheckedDate()
+  {
+    String lastCheckedDate = serverList.getLastCheckedDate("dev");
+    assert(lastCheckedDate.equals("0001-01-01 BC"));
+  }
+  
+  /**
+   * Test the method getReplicationValue(resulst is true)
+   */
+  public void testGetReplicationValueTrue()
+  {
+    assert(serverList.getReplicationValue("dev"));
+  }
+  
+  /**
+   * Test the method getReplicationValue(result is false)
+   */
+  public void testGetReplicationValueFalse()
+  {
+    assert(!serverList.getReplicationValue("epsilon"));
+  }
+  
+  /**
+   * Test the method getDataReplicationValue(result is true)
+   */
+  public void testGetDataReplicationValueTrue()
+  {
+    assert(serverList.getDataReplicationValue("dev"));
+  }
+  
+  /**
+   * Test the method getDataReplicationValue(result is false)
+   */
+  public void testGetDataReplicationValueFalse()
+  {
+    assert(!serverList.getDataReplicationValue("epsilon"));
+  }
+
+  /**
+   * Test the method getHubValue(result is true)
+   */
+  public void testGetHubValueTrue()
+  {
+    assert(serverList.getHubValue("dev"));
+  }
+  
+  /**
+   * Test the method getHubValue(result is false)
+   */
+  public void testGetHubValueFalse()
+  {
+    assert(!serverList.getHubValue("epsilon"));
+  }  
+
+   
+}//ReplicationServerListTest

Index: src/xmltables_postgres.sql
===================================================================
--- src/xmltables_postgres.sql	(revision 1291)
+++ src/xmltables_postgres.sql	(revision 1292)
@@ -48,11 +48,13 @@
   serverid INT8 default nextval('xml_replication_id_seq'), 
   server VARCHAR(512),
   last_checked DATE,
-  replicate INT8, 
+  replicate INT8,
+  datareplicate INT8,
+  hub INT8,
   CONSTRAINT xml_replication_pk PRIMARY KEY (serverid)
 );  
 
-INSERT INTO xml_replication (serverid, server, replicate) VALUES ('1', 'localhost', '0');
+INSERT INTO xml_replication (server, replicate, datareplicate, hub) VALUES ('localhost', '0', '0', '0');
 
 /* 
  * Nodes -- table to store XML Nodes (both elements and attributes)
Index: src/xmltables.sql
===================================================================
--- src/xmltables.sql	(revision 1291)
+++ src/xmltables.sql	(revision 1292)
@@ -52,7 +52,9 @@
   serverid      NUMBER(20),
   server        VARCHAR2(512),
   last_checked  DATE,
-  replicate     NUMBER(1), 
+  replicate     NUMBER(1),
+  datareplicate NUMBER(1),
+  hub NUMBER(1),
   CONSTRAINT xml_replication_pk PRIMARY KEY (serverid)
 );  
   
@@ -66,8 +68,8 @@
 END;
 /
 
-INSERT INTO xml_replication (serverid, server, replicate)
- VALUES ('1', 'localhost', '0');
+INSERT INTO xml_replication (server, replicate, datareplicate, hub)
+ VALUES ('localhost', '0', '0', '0');
 
 /* 
  * Nodes -- table to store XML Nodes (both elements and attributes)
Index: src/edu/ucsb/nceas/metacat/ReplicationServer.java
===================================================================
--- src/edu/ucsb/nceas/metacat/ReplicationServer.java	(nonexistent)
+++ src/edu/ucsb/nceas/metacat/ReplicationServer.java	(revision 1292)
@@ -0,0 +1,145 @@
+/**
+ *  '$RCSfile$'
+ *    Purpose: A class represent a server in xml_replcation table
+ *  Copyright: 2000 Regents of the University of California and the
+ *             National Center for Ecological Analysis and Synthesis
+ *    Authors: Jing Tao
+ *    Release: @release@
+ *
+ *   '$Author$'
+ *     '$Date$'
+ * '$Revision$'
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+
+package edu.ucsb.nceas.metacat;
+
+/**
+ * A class express a entry in xml_replication. It include server name,
+ * lastChechedDate, replication or not, dataReplication or not, hub or not
+ */
+ 
+public class ReplicationServer
+{
+  private String serverName = null; //server name
+  private String lastCheckedDate = null; //string of last 
+  private boolean replication = false; //replciate xml document or not
+  private boolean dataReplication = false; //replciate data file or not
+                                           //it is relative to replcation
+                                           //if replication is false, it should
+                                           //be false
+  private boolean hub = false; //it is hub or not. Hub means the localhost can
+                               //replcate documents to the server if the 
+                               //document's home server is not localhost
+  /**
+   * Consturctor of ReplicationServer
+   */
+  public ReplicationServer()
+  {
+    this.serverName = null;
+    this.lastCheckedDate = null;
+    this.replication = false;
+    this.dataReplication = false;
+    this.hub = false;
+  }//constructor
+  
+  /**
+   * Get server name
+   */
+  public String getServerName()
+  {
+    return this.serverName;
+  }//getServerName
+  
+  /**
+   * Set a sting as server name
+   * @param myServerName, the string will set to object's serverName
+   */
+  public void setServerName(String myServerName)
+  {
+    this.serverName = myServerName;
+  }//setServerName
+  
+  /**
+   * Get last checked date
+   */
+  public String getLastCheckedDate()
+  {
+    return this.lastCheckedDate;
+  }//getLastCheckedDate
+  
+  /**
+   * Set a string as last checked date
+   * @Param myLastCheckedDate, the string will set to object's lastCheckedDate
+   */
+  public void setLastCheckedDate(String myLastCheckedDate)
+  {
+    this.lastCheckedDate = myLastCheckedDate;
+  }//setLastCheckedDate
+   
+  /**
+   * Get replication xml or not option
+   */
+  public boolean getReplication()
+  {
+    return this.replication;
+  }//getReplication
+  
+  /**
+   * Set replication option
+   * @param myReplication, the option will set to object's replication
+   */
+  public void setReplication(boolean myReplication)
+  {
+    this.replication = myReplication;
+  }//setReplication
+  
+  /**
+   * Get datareplication xml or not option
+   */
+  public boolean getDataReplication()
+  {
+    return this.dataReplication;
+  }//getDataReplication
+  
+  /**
+   * Set data replication option
+   * @param myDataReplication, the option will set to object's datareplication
+   */
+  public void setDataReplication(boolean myDataReplication)
+  {
+    this.dataReplication = myDataReplication;
+  }//setDataReplication   
+   
+  /**
+   * Get hub option
+   */
+  public boolean getHub()
+  {
+    return this.hub;
+  }//getHub
+  
+  /**
+   * Set hub option
+   * @param myHub, the option will set to object's hub option
+   */
+  public void setHub(boolean myHub)
+  {
+    this.hub = myHub;
+  }//setHub     
+  
+}//class ReplicationServer
+

